<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>physicallayer/entitytpl.h Source File (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">physicallayer/entitytpl.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    Crystal Space Entity Layer</span>
<a name="l00003"></a>00003 <span class="comment">    Copyright (C) 2005 by Jorrit Tyberghein</span>
<a name="l00004"></a>00004 <span class="comment">  </span>
<a name="l00005"></a>00005 <span class="comment">    This library is free software; you can redistribute it and/or</span>
<a name="l00006"></a>00006 <span class="comment">    modify it under the terms of the GNU Library General Public</span>
<a name="l00007"></a>00007 <span class="comment">    License as published by the Free Software Foundation; either</span>
<a name="l00008"></a>00008 <span class="comment">    version 2 of the License, or (at your option) any later version.</span>
<a name="l00009"></a>00009 <span class="comment">  </span>
<a name="l00010"></a>00010 <span class="comment">    This library is distributed in the hope that it will be useful,</span>
<a name="l00011"></a>00011 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00012"></a>00012 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00013"></a>00013 <span class="comment">    Library General Public License for more details.</span>
<a name="l00014"></a>00014 <span class="comment">  </span>
<a name="l00015"></a>00015 <span class="comment">    You should have received a copy of the GNU Library General Public</span>
<a name="l00016"></a>00016 <span class="comment">    License along with this library; if not, write to the Free</span>
<a name="l00017"></a>00017 <span class="comment">    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.</span>
<a name="l00018"></a>00018 <span class="comment">*/</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __CEL_PL_ENTITYTEMP__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __CEL_PL_ENTITYTEMP__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/cstypes_8h.html">cstypes.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/scf_8h.html">csutil/scf.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/csutil_2strset_8h.html">csutil/strset.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/set_8h.html">csutil/set.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/vector2_8h.html">csgeom/vector2.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/vector3_8h.html">csgeom/vector3.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/cscolor_8h.html">csutil/cscolor.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;physicallayer/datatype.h&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">struct </span><a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>;
<a name="l00034"></a>00034 <span class="keyword">struct </span><a class="code" href="structiCelPropertyClassTemplate.html" title="This is a property class template for an entity.">iCelPropertyClassTemplate</a>;
<a name="l00035"></a>00035 <span class="keyword">struct </span><a class="code" href="structiCelPropertyClass.html" title="This is a property class for an entity.">iCelPropertyClass</a>;
<a name="l00036"></a>00036 <span class="keyword">struct </span><a class="code" href="structiCelParameterBlock.html" title="This interface is a parameter block that can be used to pass parameters through SendMessage() in a be...">iCelParameterBlock</a>;
<a name="l00037"></a>00037 
<a name="l00041"></a><a class="code" href="structiCelEntityTemplate.html">00041</a> <span class="keyword">struct </span><a class="code" href="structiCelEntityTemplate.html" title="This is an entity template.">iCelEntityTemplate</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00042"></a>00042 {
<a name="l00043"></a>00043   SCF_INTERFACE (<a class="code" href="structiCelEntityTemplate.html" title="This is an entity template.">iCelEntityTemplate</a>, 0, 0, 1);
<a name="l00044"></a>00044 
<a name="l00049"></a>00049   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiObject.html">iObject</a>* <a class="code" href="structiCelEntityTemplate.html#aceccd02f43b6dd7dd98f698341cf9f4a" title="Get the iObject for this entity template.">QueryObject</a> () = 0;
<a name="l00050"></a>00050 
<a name="l00055"></a>00055   <span class="keyword">virtual</span> <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="structiCelEntityTemplate.html#acf81c0aaaf027783db9fb0dbd4422d65" title="Get the name of this template.">GetName</a> () <span class="keyword">const</span> = 0;
<a name="l00056"></a>00056 
<a name="l00061"></a>00061   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelEntityTemplate.html#ad7e62f9e9c0f99e7ede6edc8c0e37632" title="Set the name of this template.">SetName</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* n) = 0;
<a name="l00062"></a>00062 
<a name="l00066"></a>00066   <span class="keyword">virtual</span> <a class="code" href="structiCelPropertyClassTemplate.html" title="This is a property class template for an entity.">iCelPropertyClassTemplate</a>* <a class="code" href="structiCelEntityTemplate.html#ac47fe787a2379374ea60eb6fe3c5025b" title="Create a new property class template for this entity.">CreatePropertyClassTemplate</a> () = 0;
<a name="l00067"></a>00067 
<a name="l00074"></a>00074   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelEntityTemplate.html#ab01c190812566b105f23b081cdcbdb96" title="Set the behaviour associated with this template.">SetBehaviour</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* layer, <span class="keyword">const</span> <span class="keywordtype">char</span>* behaviour) = 0;
<a name="l00075"></a>00075 
<a name="l00079"></a>00079   <span class="keyword">virtual</span> <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="structiCelEntityTemplate.html#a1ba93485bac47a92122aa3a29a96cedd" title="Get the layer for this template.">GetBehaviourLayer</a> () <span class="keyword">const</span> = 0;
<a name="l00080"></a>00080 
<a name="l00084"></a>00084   <span class="keyword">virtual</span> <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="structiCelEntityTemplate.html#a1e92218b2c9390a23ce530e11f1a5dc1" title="Get the behaviour for this template.">GetBehaviour</a> () <span class="keyword">const</span> = 0;
<a name="l00085"></a>00085 
<a name="l00091"></a>00091   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelEntityTemplate.html#a4ce4b28d3043533bf9a88f0b0e2cce1b" title="Add a message to be sent to the created behaviour.">AddMessage</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* msgid, <a class="code" href="structiCelParameterBlock.html" title="This interface is a parameter block that can be used to pass parameters through SendMessage() in a be...">iCelParameterBlock</a>* params) = 0;
<a name="l00092"></a>00092 
<a name="l00098"></a>00098   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelEntityTemplate.html#ae0b4b111d1e0b30fd909fecab45882e2" title="Add a class to this entity.">AddClass</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> cls) = 0;
<a name="l00099"></a>00099 
<a name="l00103"></a>00103   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelEntityTemplate.html#aff21f1484e1dcb3db093423d0e03588f" title="Remove a class from this entity.">RemoveClass</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> cls) = 0;
<a name="l00104"></a>00104 
<a name="l00108"></a>00108   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelEntityTemplate.html#a6ad2194d5e574a7e901518ae89ead470" title="Check if this entity belongs to some class.">HasClass</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> cls) = 0;
<a name="l00109"></a>00109 
<a name="l00113"></a>00113   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsSet.html">csSet&lt;csStringID&gt;</a>&amp; <a class="code" href="structiCelEntityTemplate.html#a80b3e69c956b839b328a1a24939cc982" title="Return the set of classes for this entity.">GetClasses</a> () <span class="keyword">const</span> = 0;
<a name="l00114"></a>00114 };
<a name="l00115"></a>00115 
<a name="l00120"></a><a class="code" href="structiCelPropertyClassTemplate.html">00120</a> <span class="keyword">struct </span><a class="code" href="structiCelPropertyClassTemplate.html" title="This is a property class template for an entity.">iCelPropertyClassTemplate</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00121"></a>00121 {
<a name="l00122"></a>00122   SCF_INTERFACE (<a class="code" href="structiCelPropertyClassTemplate.html" title="This is a property class template for an entity.">iCelPropertyClassTemplate</a>, 0, 0, 1);
<a name="l00123"></a>00123 
<a name="l00127"></a>00127   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelPropertyClassTemplate.html#a38e9716d2b02a6bef28e2988d8356821" title="Set the name of this property class.">SetName</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* name) = 0;
<a name="l00128"></a>00128 
<a name="l00132"></a>00132   <span class="keyword">virtual</span> <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="structiCelPropertyClassTemplate.html#a268416c398135fd21b319aa2d7026b81" title="Get the name of this property class.">GetName</a> () <span class="keyword">const</span> = 0;
<a name="l00133"></a>00133 
<a name="l00140"></a>00140   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelPropertyClassTemplate.html#a4945212278c4b8b9636467eb16f627a9" title="Set the optional tag of this property class.">SetTag</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* tagname) = 0;
<a name="l00141"></a>00141 
<a name="l00146"></a>00146   <span class="keyword">virtual</span> <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="structiCelPropertyClassTemplate.html#a6fbc67be394ba9f9f97587abd25e8b34" title="Get the tag of this property class or return 0 if there is no tag.">GetTag</a> () <span class="keyword">const</span> = 0;
<a name="l00147"></a>00147 
<a name="l00152"></a>00152   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelPropertyClassTemplate.html#a1fc047ea3b4ffd5b7648ceecc844106c" title="Set a property with variables instead of a predefined value.">SetPropertyVariable</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> propertyID, celDataType type,
<a name="l00153"></a>00153         <span class="keyword">const</span> <span class="keywordtype">char</span>* varname) = 0;
<a name="l00154"></a>00154 
<a name="l00167"></a>00167   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelPropertyClassTemplate.html#a0db2427faa00c60b8c371e632828afd7" title="Set a generic property.">SetProperty</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> propertyID, <span class="keywordtype">long</span> value) = 0;
<a name="l00168"></a>00168 
<a name="l00172"></a>00172   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelPropertyClassTemplate.html#a0db2427faa00c60b8c371e632828afd7" title="Set a generic property.">SetProperty</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> propertyID, <span class="keywordtype">float</span> value) = 0;
<a name="l00173"></a>00173 
<a name="l00177"></a>00177   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelPropertyClassTemplate.html#a0db2427faa00c60b8c371e632828afd7" title="Set a generic property.">SetProperty</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> propertyID, <span class="keywordtype">bool</span> value) = 0;
<a name="l00178"></a>00178 
<a name="l00182"></a>00182   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelPropertyClassTemplate.html#a0db2427faa00c60b8c371e632828afd7" title="Set a generic property.">SetProperty</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> propertyID, <span class="keyword">const</span> <span class="keywordtype">char</span>* value) = 0;
<a name="l00183"></a>00183 
<a name="l00187"></a>00187   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelPropertyClassTemplate.html#a0db2427faa00c60b8c371e632828afd7" title="Set a generic property.">SetProperty</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> propertyID, <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector2.html">csVector2</a>&amp; value) = 0;
<a name="l00188"></a>00188 
<a name="l00192"></a>00192   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelPropertyClassTemplate.html#a0db2427faa00c60b8c371e632828afd7" title="Set a generic property.">SetProperty</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> propertyID, <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; value) = 0;
<a name="l00193"></a>00193 
<a name="l00197"></a>00197   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelPropertyClassTemplate.html#a0db2427faa00c60b8c371e632828afd7" title="Set a generic property.">SetProperty</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> propertyID, <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsColor.html">csColor</a>&amp; value) = 0;
<a name="l00198"></a>00198 
<a name="l00202"></a>00202   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelPropertyClassTemplate.html#a0db2427faa00c60b8c371e632828afd7" title="Set a generic property.">SetProperty</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> propertyID,
<a name="l00203"></a>00203         <a class="code" href="structiCelPropertyClass.html" title="This is a property class for an entity.">iCelPropertyClass</a>* value) = 0;
<a name="l00204"></a>00204 
<a name="l00208"></a>00208   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelPropertyClassTemplate.html#a0db2427faa00c60b8c371e632828afd7" title="Set a generic property.">SetProperty</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> propertyID, <a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* entity) = 0;
<a name="l00209"></a>00209 
<a name="l00214"></a>00214   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelPropertyClassTemplate.html#a3cb921a9955f02448c7ceb79e394aa9c" title="Perform an action with a generic parameter list.">PerformAction</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> actionID,
<a name="l00215"></a>00215         <a class="code" href="structiCelParameterBlock.html" title="This interface is a parameter block that can be used to pass parameters through SendMessage() in a be...">iCelParameterBlock</a>* params) = 0;
<a name="l00216"></a>00216 };
<a name="l00217"></a>00217 
<a name="l00218"></a>00218 <span class="preprocessor">#endif // __CEL_PL_ENTITYTEMP__</span>
<a name="l00219"></a>00219 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
